#ifndef STATIC_CONTAINER_HASH_H

#define STATIC_CONTAINER_HASH_H

#include <boost/call_traits.hpp>
#include <iterator>
#include "static_container/STATIC_CONTAINER_MEMBERTYPEDEF.h"

namespace static_container {
	///	Cӂ̏ReiɃnbVC^[tF[X ( std::map ʌ݊ ) t^ReiA_v^
	/**
	 *	Rei std::pair< Key, Value > i[\łȂ΂ȂȂB
	 *
	 *	}A폜Ȃǂ\B
	 *
	 *	}́ARei push_back() gĂB
	 *	폜́ARei erase() gĂB
	 *	NÁARei clear() gĂB
	 */
	template < typename Key, typename Value, typename Cont, typename KeyEqual = std::equal_to< Key > >
	class hash {
	public:
		typedef std::pair< Key, Value >			pair_type;
		STATIC_CONTAINER_MEMBERTYPEDEF( pair_type );
		typedef typename Cont::iterator			iterator;
		typedef typename Cont::const_iterator	const_iterator;
		typedef typename boost::call_traits< KeyEqual >::param_type key_equal;
	
	private:
		Cont		cont_;
		KeyEqual	equal_;

		struct key_comp {
			typedef typename boost::call_traits< Key >::param_type	key_param;
			key_param	key;
			key_equal	keyEqual;
			key_comp( key_param k, key_equal equal ) : key( k ), keyEqual( equal ) {}
			bool operator () ( typename boost::call_traits< value_type >::param_type pair ) const {
				return keyEqual( key, pair.first );
			}
		};

		iterator push_back( const_reference v ) {
			cont_.push_back( v );
			iterator it = end();
			--it;
			return it;
		}
	public:
		hash( key_equal equal = KeyEqual() ) : cont_(), equal_( equal ) {}
		hash( const Cont& cont, key_equal equal = KeyEqual() ) : cont_( cont ), equal_( equal ) {}

		iterator begin() {
			return cont_.begin();
		}

		iterator end() {
			return cont_.end();
		}

		const_iterator begin() const {
			return cont_.begin();
		}

		const_iterator end() const {
			return cont_.end();
		}

		const_iterator find( typename boost::call_traits< Key >::param_type key ) const {
			return find_if( begin(), end(), key_comp( key, equal_ ) );
		}

		iterator find( typename boost::call_traits< Key >::param_type key ) {
			return find_if( begin(), end(), key_comp( key, equal_ ) );
		}

		bool empty() const {
			return begin() == end();
		}

		size_type size() const {
			return std::distance( begin(), end() );
		}
		
		const Value& search( typename boost::call_traits< Key >::param_type key ) const {
			return find( key )->second;
		}

		Value& search( typename boost::call_traits< Key >::param_type key ) {
			return find( key )->second;
		}
		
		///	}Axɂł֗C^[tF[X
		/**
		 *	PȂ錟ړIłނ݂ɎgƁA}xŝŁAgpɂ͏\ӂB
		 */
		Value& operator [] ( typename boost::call_traits< Key >::param_type key ) {
			iterator it = find( key );
			if ( it != end() ) {
				return it->second;
			} else {
				return push_back( value_type( key, Value() ) )->second;
			}
		}

		///	std::map Ɠl pair gđ}̃Ce[^[ƁA}Ƃ̗LԂ
		/**
		 *	@return first A}̃Ce[^[Bsecond }Ƃ̗L bool Ȃ pair Ԃ
		 */
		std::pair< iterator, bool > insert( const_reference v ) {
			iterator it = find( v.first );
			if ( it != end() ) {
				//	łɓL[̃yÂ݂ŁAԂ
				return std::make_pair(
					it,
					false );
			} else {
				//	݂Ȃ̂ő}
				return std::make_pair(
					push_back( v ),
					false );
			}
		}
		void erase( iterator it ) {
			cont_.erase( it );
		}
		void clear() {
			cont_.clear();
		}
		
		///	Rei擾
		Cont& get_container() {
			return cont_;
		}
		
		///	Rei擾
		const Cont& get_container() const {
			return cont_;
		}
	};
}

#endif
