#ifndef STATIC_CONTAINER_LIST_H

#define STATIC_CONTAINER_LIST_H

#include "static_container/lodge_list.h"
#include <boost/utility.hpp>

namespace static_container {
		
	///	std::list ʌ݊AÓImۑoXg
	/**
	 *	őTCY MaxSize ̗̈zƂĐÓImۂA
	 *	͈͓̔ŃXgJ肵ĂB
	 *
	 *	AC͐邱ƂۏႷB
	 */
	template < typename Value, size_type MaxSize >
	class list :
		private boost::base_from_member< list_node_pool< Value, MaxSize > >,
		public lodge_list< Value >,
		public compare_methods< list< Value, MaxSize > > {

		typedef boost::base_from_member< list_node_pool< Value, MaxSize > >	pool;
		typedef lodge_list< Value >	parent;
	public:
		list() : parent( pool::member ) {}

		list( const list& other ) : parent( pool::member ) {
			insert( begin(), other.begin(), other.end() );
		}
		list& operator = ( const list& other ) {
			if ( this != &other ) {
				clear();
				insert( begin(), other.begin(), other.end() );
			}
			return *this;
		}
		
		///	^?
		bool full() const {
			return pool::member.full();
		}

		///	őTCY擾
		static size_type max_size() {
			return MaxSize;
		}
	};
}

#endif
