#ifndef STATIC_CONTIANER_TEST_BASIC_SEQUENCE_H

#define STATIC_CONTIANER_TEST_BASIC_SEQUENCE_H

#include <boost/test/minimal.hpp>
#include "static_container/integer.h"
#include <boost/assert.hpp>
#include "static_container/test/del_counter.h"

namespace static_container {
	namespace test {
		///	V[PXRei̊{eXg
		template < typename ContGen >
		void basic_sequence() {
			struct local_func {
				static void test_del_counter() {
					const size_type	size = 10;
					typedef ContGen::gen< del_counter, size >::type	Cont;
					BOOST_REQUIRE( size == Cont::max_size() );
					size_type del_count = 0;
					{
						Cont cont;
						BOOST_REQUIRE( cont.empty() );
						BOOST_REQUIRE( 0 == cont.size() );
						cont.push_back( del_counter( del_count ) );
						//	ꎞIuWFNg̔jmF
						BOOST_REQUIRE( 1 == del_count );
						BOOST_REQUIRE( !cont.empty() );
						BOOST_REQUIRE( 1 == cont.size() );
					}
					//	cont ̃fXgN^ɂmF
					BOOST_REQUIRE( 2 == del_count );
					
					del_count = 0;
					{
						Cont cont;
						for ( size_type i = 0; i < size; ++i ) {
							cont.push_back( del_counter( del_count ) );
							BOOST_REQUIRE( i + 1 == cont.size() );
						}
						BOOST_REQUIRE( 10 == del_count );
						for ( size_type i = 0; i < size; ++i ) {
							cont.pop_back();
							BOOST_REQUIRE( size - i - 1 == cont.size() );
						}
						BOOST_REQUIRE( 20 == del_count );
					}
					BOOST_REQUIRE( 20 == del_count );

					del_count = 0;
					{
						Cont cont;
						for ( size_type i = 0; i < size; ++i ) {
							cont.push_back( del_counter( del_count ) );
							BOOST_REQUIRE( i + 1 == cont.size() );
						}
						BOOST_REQUIRE( 10 == del_count );
						cont.clear();
						BOOST_REQUIRE( 20 == del_count );
					}
					BOOST_REQUIRE( 20 == del_count );
				}
				
				static void test_int() {
					const size_type size = 10;
					typedef ContGen::gen< int, size >::type	Cont;
					typedef Cont::iterator			iterator;
					typedef Cont::const_iterator	const_iterator;
					BOOST_REQUIRE( size == Cont::max_size() );
					
					Cont cont;
					cont.push_back( 123 );
					BOOST_REQUIRE( 123 == cont.front() );
					cont.front() = 33;
					BOOST_REQUIRE( 33 == cont.front() );
					cont.push_back( 53 );
					BOOST_REQUIRE( 33 == cont.front() );
					BOOST_REQUIRE( 53 == cont.back() );
					
					Cont::iterator it = cont.begin();
					BOOST_REQUIRE( 33 == *it );
					++it;
					BOOST_REQUIRE( 53 == *it );
					
					Cont another( cont );
					BOOST_REQUIRE( another == cont );
					cont.push_back( 0 );
					BOOST_REQUIRE( another != cont );
					BOOST_REQUIRE( another < cont );
					++another.back();
					BOOST_REQUIRE( cont < another );
					another = cont;
					BOOST_REQUIRE( cont == another );
					cont = cont; // ȑeXg
					BOOST_REQUIRE( cont == another );
					
					cont.clear();
					
					for ( int i = 0; i < static_cast< int >( size ); ++i ) {
						cont.push_back( i );
					}
					for ( iterator it = cont.begin(); it != cont.end(); ++it ) {
 						BOOST_REQUIRE( std::distance( cont.begin(), it ) == *it );
					}
					cont.clear();
					
					//	iterator  const_iterator ւ̈Öق̃LXg͉\H
					const_iterator cit = cont.begin();
					
					//	dNA
					for ( int i = 0; i < 10; ++i ) {
						cont.clear();
					}
				}
			};
			
			local_func::test_del_counter();
			local_func::test_int();
		}
	}
}

#endif