#include "static_container/test/assert_new.h"
#include <boost/test/minimal.hpp>
#include "static_container/string.h"
#include "static_container/test/dump.h"

using namespace static_container;

///	@test static_container::string
void test_basic() {
	string< 10 >	s;
	BOOST_REQUIRE( s.empty() );
	BOOST_REQUIRE( 0 == s.size() );
	string< 10 >	str( "hello" );
	BOOST_REQUIRE( "hello" == str );
	BOOST_REQUIRE( strlen( "hello" ) == str.size() );
	string< 12 >	str2( "hello" );
	BOOST_REQUIRE( str2 == str );
	string< 15 >	str3( str );
	str3 += str2;
	BOOST_REQUIRE( "hellohello" == str3 );
	str3.push_back( 'c' );
	BOOST_REQUIRE( "hellohelloc" == str3 );
	str3.pop_back();
	BOOST_REQUIRE( "hellohello" == str3 );
	str3.append( str2 );
	BOOST_REQUIRE( "hellohellohello" == str3 );
}

///	@test static_container::string
void test_compare() {
	string< 10 >	s, t;
	BOOST_REQUIRE( t == s );
	BOOST_REQUIRE( "" == s );
	BOOST_REQUIRE( "h" != s );
	BOOST_REQUIRE( s < "h" );
	BOOST_REQUIRE( false == ( s < t ) );
	s = "hello";
	BOOST_REQUIRE( "hello" == s );
	BOOST_REQUIRE( "hello" != t );
	t = "hellp";
	BOOST_REQUIRE( s < t );
}

///	@test static_container::string
void test_dump() {
	string< 10 >	s;
	test::dump( s );
	s = "hello";
	test::dump( s );
	s = "{";
	test::dump( s );	
}

int test_main( int argc, char* argv[] ) {
	test::begin(); // new Ăяoɓ{苶I
	test_basic();
	test_compare();
	test_dump();
	return 0;
}